package info.textgrid.lab.collatex.ui;

import info.textgrid.lab.collatex.ui.parts.CollationSetEditor;
import info.textgrid.lab.collatex.ui.parts.RegularisationEditor;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPartListener2;
import org.eclipse.ui.IPerspectiveFactory;
import org.eclipse.ui.IWorkbenchPartReference;
import org.eclipse.ui.PlatformUI;

public class CollateXPerspective implements IPerspectiveFactory {

	public static final String ID = "info.textgrid.lab.collatex.ui.CollateXPerspective"; //$NON-NLS-1$
	private IPartListener2 partListener;

	/**
	 * Creates the initial layout for a page.
	 */
	@Override
	public void createInitialLayout(final IPageLayout layout) {
		final String editorArea = layout.getEditorArea();
		addFastViews(layout);
		addViewShortcuts(layout);
		addPerspectiveShortcuts(layout);
		layout.addView("info.textgrid.lab.navigator.view", IPageLayout.LEFT, //$NON-NLS-1$
				0.25f, IPageLayout.ID_EDITOR_AREA);
		{
			final IFolderLayout folderLayout = layout.createFolder("results", //$NON-NLS-1$
					IPageLayout.BOTTOM, 0.5f, IPageLayout.ID_EDITOR_AREA);
			folderLayout
			.addView("info.textgrid.lab.collatex.ui.parts.GridResultView"); //$NON-NLS-1$
			folderLayout
			.addView("info.textgrid.lab.collatex.ui.parts.VariantGraphView"); //$NON-NLS-1$
			folderLayout
			.addView("info.textgrid.lab.collatex.ui.parts.TEIResultsView"); //$NON-NLS-1$
			//			folderLayout
			//			.addView("info.textgrid.lab.collatex.ui.parts.VerticalTableView"); //$NON-NLS-1$
		}

		if (partListener == null)
			partListener = new IPartListener2() {

			@Override
			public void partActivated(
					final IWorkbenchPartReference partRef) {
				// TODO Auto-generated method stub

			}

			@Override
			public void partBroughtToTop(
					final IWorkbenchPartReference partRef) {
				// TODO Auto-generated method stub

			}

			@Override
			public void partClosed(final IWorkbenchPartReference partRef) {
				// TODO Auto-generated method stub

			}

			@Override
			public void partDeactivated(
					final IWorkbenchPartReference partRef) {
				// TODO Auto-generated method stub

			}

			@Override
			public void partOpened(final IWorkbenchPartReference partRef) {
				if (partRef.getId().equals(CollationSetEditor.ID)
						|| partRef.getId().equals(
								RegularisationEditor.ID)) {
					//					ArrangeEditorsHandler.sortItOut();
					}
			}

			@Override
			public void partHidden(final IWorkbenchPartReference partRef) {
				// TODO Auto-generated method stub

			}

			@Override
			public void partVisible(
					final IWorkbenchPartReference partRef) {
				// TODO Auto-generated method stub

			}

			@Override
			public void partInputChanged(
					final IWorkbenchPartReference partRef) {
				// TODO Auto-generated method stub

			}

		};

		PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage()
		.addPartListener(partListener);
	}

	/**
	 * Add fast views to the perspective.
	 */
	private void addFastViews(final IPageLayout layout) {
	}

	/**
	 * Add view shortcuts to the perspective.
	 */
	private void addViewShortcuts(final IPageLayout layout) {
	}

	/**
	 * Add perspective shortcuts to the perspective.
	 */
	private void addPerspectiveShortcuts(final IPageLayout layout) {
	}

}
